clear all
i=1;

global JD_capture JD_escape a_orbit i_orbit delta_t Perturbation1 Perturbation2
global ra_capture ra_escape dec_capture dec_escape mu
global C3_c C3_e a_h_escape a_h_capture
global DV_ESCAPE  DV_CAPTURE deltav_ascesa deltav_discesa DV_TOTAL mp_arrivo mp_ritorno ms_ritorno ms_arrivo
global mi_ritorno  mi_ascesa mu_arrivo mi_discesa mp_ascesa mp_discesa ms_discesa mu_discesa ms_ascesa 

%initial data
a_orbit=20448; % semi-major axis[Km]
i_deg=40;     %p.o inclination
alpha_c=113.8; %capture right ascension
delta_c=-1.7; %capture declination
C3_c=2.92^2; %capture energy level [Km^2/s^2]
alpha_e=-53.5; %escape right ascension 
delta_e=5.3; %escape declination
C3_e=2.47^2; %escape energy level [Km^2/s^2]
rp_min=3389.5+100; %minimum limit
e_max=1-rp_min/a_orbit;

%date
JD_capture=julianday(7, 27, 2042);
JD_escape=julianday(7, 31, 2043);
delta_t=(JD_escape-JD_capture); %giorni
%delta_t=0; %da attivare se non perturbata


%degree to radiant right ascension and declination
ra_capture=alpha_c*pi/180;
ra_escape=alpha_e*pi/180;
dec_capture=delta_c*pi/180;
dec_escape=delta_e*pi/180;

ra_capture=pi-ra_capture;       % Right ascension capture hyperbola [rad]
dec_capture=-dec_capture;       % Declination capture hyperbola [rad]
 

i_orbit=i_deg*pi/180;
mu=42828;  %standard gravitational parameter

LB=[0 0 0 0 0]*pi/180;
UB=[360 360 360 360 e_max*180/pi]*pi/180;

options = optimoptions('ga','SelectionFcn',@selectiontournament,'EliteCount',10 ,...
        'CrossoverFraction',0.2,'PlotFcn',{@gaplotbestf,@gaplotmaxconstr},'Display',...
        'iter','InitialPopulationRange', [0;2*pi],'MigrationDirection', 'both' );

toll=1e-2;
diff=1;
Res_test=10;

%[optimal_parameters, DELTA_V_MIN, val,output,population,scores]=ga(@mission1_optim_dv,5,[],[],[],[],LB,UB,[],options);

[optimal_parameters, M_TOTAL_MIN, val,output,population,scores]=ga(@mission1_optim_mass,5,[],[],[],[],LB,UB,[],options);
opt_capture=optimal_parameters*180/pi;
% Results

LAN_capture(i)=opt_capture(1);
RAAN_capture(i)=opt_capture(2);
INJECTION_capture(i)=opt_capture(3);
INJECTION_escape(i)=opt_capture(4);
ECCENTRICITY(i)=optimal_parameters(5);
%DELTA_V_MIN_OPTIM=DELTA_V_MIN;
M_TOTAL_optim(i)=M_TOTAL_MIN;


mp_TOTAL=mp_ascesa+mp_discesa+mp_arrivo+mp_ritorno; 
DV_total=DV_TOTAL+deltav_ascesa+deltav_discesa;
%% PARAMETRI ORBITALI CATTURA

H_po_c=cross(r_capture, V_capture);
i_po_c=acos(H_po_c(3)/norm(H_po_c));
n_po_c=cross([0;0;1],H_po_c)/norm(H_po_c);
if n_po_c(2)>=0
    RAAN_po_c=acos(n_po_c(1)/norm(n_po_c));
else
    RAAN_po_c=2*pi-acos(n_po_c(1)/norm(n_po_c));
end
e_po_c=cross(V_capture,H_po_c)/mu-r_capture/norm(r_capture);

if e_po_c(3)>=0
    AP_capt_c=acos((n_po_c'*e_po_c)/(norm(n_po_c)*norm(e_po_c)));
else
    AP_capt_c=2*pi-acos((n_po_c'*e_po_c)/(norm(n_po_c)*norm(e_po_c)));
end

%% PARAMETRI ORBITALI ESCAPE

H_po_e=cross(r_escape, V_escape);
i_po_e=acos(H_po_e(3)/norm(H_po_e));
n_po_e=cross([0;0;1],H_po_e)/norm(H_po_e);
if n_po_e(2)>=0
    RAAN_po_e=acos(n_po_e(1)/norm(n_po_e));
else
    RAAN_po_e=2*pi-acos(n_po_e(1)/norm(n_po_e));
end
e_po_e=cross(V_escape,H_po_e)/mu-r_escape/norm(r_escape);

if e_po_e(3)>=0
    AP_capt_e=acos((n_po_e'*e_po_e)/(norm(n_po_e)*norm(e_po_e)));
else
    AP_capt_e=2*pi-acos((n_po_e'*e_po_e)/(norm(n_po_e)*norm(e_po_e)));
end

%% PARAMETRI ORBITALI IPERBOLE CATTURA
H_hyp_c=cross(r_capture, V_h_capture);
i_hyp_c=acos(H_hyp_c(3)/norm(H_hyp_c));
n_hyp_c=cross([0;0;1],H_hyp_c)/norm(H_hyp_c);
if n_hyp_c(2)>=0
    RAAN_hyp_c=acos(n_hyp_c(1)/norm(n_hyp_c));
else
    RAAN_hyp_c=2*pi-acos(n_hyp_c(1)/norm(n_hyp_c));
end
e_hyp_c=cross(V_h_capture,H_hyp_c)/mu-r_capture/norm(r_capture);
if e_hyp_c(3)>=0
    AP_hyp_c=acos((n_hyp_c'*e_hyp_c)/(norm(n_hyp_c)*norm(e_hyp_c)));
else
    AP_hyp_c=2*pi-acos((n_hyp_c'*e_hyp_c)/(norm(n_hyp_c)*norm(e_hyp_c)));
end


%% PARAMETRI ORBITALI IPERBOLE FUGA
H_hyp_e=cross(r_escape, V_h_escape);
i_hyp_e=acos(H_hyp_e(3)/norm(H_hyp_e));
n_hyp_e=cross([0;0;1],H_hyp_e)/norm(H_hyp_e);
if n_hyp_e(2)>=0
    RAAN_hyp_e=acos(n_hyp_e(1)/norm(n_hyp_e));
else
    RAAN_hyp_e=2*pi-acos(n_hyp_e(1)/norm(n_hyp_e));
end
e_hyp_e=cross(V_h_escape,H_hyp_e)/mu-r_escape/norm(r_escape);
if e_hyp_e(3)>=0
    AP_hyp_e=acos((n_hyp_e'*e_hyp_e)/(norm(n_hyp_e)*norm(e_hyp_e)));
else
    AP_hyp_e=2*pi-acos((n_hyp_e'*e_hyp_e)/(norm(n_hyp_e)*norm(e_hyp_e)));
end

% %% PARAMETRI ORBITALI SECONDA IPERBOLE CATTURA
% H_hyp_c_2=cross(r_capture, V_h_capture_2);
% i_hyp_c_2=acos(H_hyp_c_2(3)/norm(H_hyp_c_2));
% n_hyp_c_2=cross([0;0;1],H_hyp_c_2)/norm(H_hyp_c_2);
% if n_hyp_c_2(2)>=0
%     RAAN_hyp_c_2=acos(n_hyp_c_2(1)/norm(n_hyp_c_2));
% else
%     RAAN_hyp_c_2=2*pi-acos(n_hyp_c_2(1)/norm(n_hyp_c_2));
% end
% e_hyp_c_2=cross(V_h_capture_2,H_hyp_c_2)/mu-r_capture/norm(r_capture);
% if e_hyp_c_2(3)>=0
%     AP_hyp_c_2=acos((n_hyp_c'*e_hyp_c_2)/(norm(n_hyp_c_2)*norm(e_hyp_c_2)));
% else
%     AP_hyp_c_2=2*pi-acos((n_hyp_c_2'*e_hyp_c_2)/(norm(n_hyp_c_2)*norm(e_hyp_c_2)));
% end
% 
% %% PARAMETRI ORBITALI SECONDA IPERBOLE FUGA
% H_hyp_e_2=cross(r_escape, V_h_escape_2);
% i_hyp_e_2=acos(H_hyp_e_2(3)/norm(H_hyp_e_2));
% n_hyp_e_2=cross([0;0;1],H_hyp_e_2)/norm(H_hyp_e_2);
% if n_hyp_e_2(2)>=0
%     RAAN_hyp_e_2=acos(n_hyp_e_2(1)/norm(n_hyp_e_2));
% else
%     RAAN_hyp_e_2=2*pi-acos(n_hyp_e_2(1)/norm(n_hyp_e_2));
% end
% e_hyp_e_2=cross(V_h_escape_2,H_hyp_e_2)/mu-r_escape/norm(r_escape);
% if e_hyp_e_2(3)>=0
%     AP_hyp_e_2=acos((n_hyp_e_2'*e_hyp_e_2)/(norm(n_hyp_e_2)*norm(e_hyp_e_2)));
% else
%     AP_hyp_e_2=2*pi-acos((n_hyp_e_2'*e_hyp_e_2)/(norm(n_hyp_e_2)*norm(e_hyp_e_2)));
% end
%% PLOT
%Mars sphere
r=3389.5; %Mars radius
[Xs,Ys,Zs]=sphere(20);
rx=r*Xs;
ry=r*Ys;
rz=r*Zs;


Grafici_optim(a_orbit, ECCENTRICITY,LAN_capture,RAAN_capture,S_vettore, S_vettore_e, r_capture, r_escape ,i_orbit,p_vector,p_escape)
hold on 
stampa_iperbole_cattura(a_h_capture,e_h_capture,AP_hyp_c,RAAN_hyp_c,i_hyp_c,phi_capture)
stampa_iperbole_escape(a_h_escape,e_h_escape,AP_hyp_e,RAAN_hyp_e,i_hyp_e,phi_escape)
hold on
%legend('Parking Orbit','Capture Hyperbola','Escape Hyperbola')
%surf(rx,ry,rz, 'HandleVisibility','off')   %se si vuole trasparenza usare 'FaceAlpha',.1

%la seguente parte è da attivare solo se c'è perturbazione in modo da
%vedere l'orbita perturbata nella condizione finale
t=delta_t*86400;
RAAN_escape=optimal_parameters(2)+Perturbation1*t;
LAN_escape=optimal_parameters(1)+Perturbation2*t;
stampa_orbita_perturbata(a_orbit,ECCENTRICITY,LAN_escape,RAAN_escape,i_orbit)
hold on
legend('Parking Orbit - Capture Condition','Capture Hyperbola','Escape Hyperbola','Parking Orbit - Escape Condition')  %da attivare se perturbato

