function Grafici_optim_orbiter(a_orbit, e_orbit,LAN_capture_orbiter,RAAN_capture_orbiter,S_vettore_orbiter, S_vettore_e_orbiter, r_escape_orbiter, r_capture_orbiter,i_orbit,p_vector_orbiter,p_escape_orbiter)

a=a_orbit;
e=e_orbit;
OMEGA=RAAN_capture_orbiter;
OMEGHINO=LAN_capture_orbiter;
i_p=i_orbit;

OMEGA=OMEGA*pi/180;
OMEGHINO=OMEGHINO*pi/180;

nu_h = 0:pi/100:2*pi;
r= a*(1-e^2)./(1+e*cos(nu_h));

x=r.*cos(nu_h);
y=r.*sin(nu_h);
z=0.*nu_h;
for i=1:size(nu_h,2)
 rPerifocal = [x(i);y(i);z(i)];
 R3_OMEGA = [cos(OMEGA), sin(OMEGA), 0; -sin(OMEGA), cos(OMEGA),0; 0,0,1];
 R1_i= [1, 0, 0; 0,cos(i_p), sin(i_p); 0,-sin(i_p), cos(i_p)];
 R3_OMEGHINO= [cos(OMEGHINO), sin(OMEGHINO), 0; -sin(OMEGHINO), cos(OMEGHINO), 0; 0,0,1];
 R_PG = R3_OMEGHINO*R1_i*R3_OMEGA;  %for perifocal to IJK
 rIJK = R_PG'* rPerifocal;

%inertial system coordinates
 xIJK(i) = rIJK(1); % lungo g1
 yIJK(i) = rIJK(2); % lungo g2
 zIJK(i) = rIJK(3); % lungo g3
 
end 
p_vector_orbiter=5000*p_vector_orbiter;
p_vector_orbiter=[linspace(0,p_vector_orbiter(1),2);linspace(0,p_vector_orbiter(2),2);linspace(0,p_vector_orbiter(3),2)];
p_escape_orbiter=5000*p_escape_orbiter;
p_escape_orbiter=[linspace(0,p_escape_orbiter(1),2);linspace(0,p_escape_orbiter(2),2);linspace(0,p_escape_orbiter(3),2)];
r_capture_orbiter=[linspace(0,r_capture_orbiter(1),2);linspace(0,r_capture_orbiter(2),2);linspace(0,r_capture_orbiter(3),2)];
r_escape_orbiter=[linspace(0,r_escape_orbiter(1),2);linspace(0,r_escape_orbiter(2),2);linspace(0,r_escape_orbiter(3),2)];
S_vettore_orbiter=5000*S_vettore_orbiter;
S_vettore_orbiter=[linspace(0,S_vettore_orbiter(1),2);linspace(0,S_vettore_orbiter(2),2);linspace(0,S_vettore_orbiter(3),2)];
S_vettore_e_orbiter=5000*S_vettore_e_orbiter;
S_vettore_e_orbiter=[linspace(0,S_vettore_e_orbiter(1),2);linspace(0,S_vettore_e_orbiter(2),2);linspace(0,S_vettore_e_orbiter(3),2)];




figure(3)
title('Optimized Trajectory')
axis([-a*2 a*2 -a*2 a*2 -2*a 2*a])
view(45,45)
hold on
plot3(0,0,0,'*k','handleVisibility','off')
%plot3(p_vector_orbiter(1,:),p_vector_orbiter(2,:),p_vector_orbiter(3,:), '-c', 'linewidth',3,'HandleVisibility','off')
%plot3(p_escape_orbiter(1,:),p_escape_orbiter(2,:),p_escape_orbiter(3,:), '-m', 'linewidth',3,'HandleVisibility','off')
plot3(r_capture_orbiter(1,:),r_capture_orbiter(2,:),r_capture_orbiter(3,:),'-k','linewidth',2.5,'HandleVisibility','off')
plot3(r_escape_orbiter(1,:),r_escape_orbiter(2,:),r_escape_orbiter(3,:),'-k','linewidth',2.5,'HandleVisibility','off')
%plot3(S_vettore_orbiter(1,:),S_vettore_orbiter(2,:),S_vettore_orbiter(3,:), '-c', 'linewidth',3,'HandleVisibility','off')
%plot3(S_vettore_e_orbiter(1,:),S_vettore_e_orbiter(2,:),S_vettore_e_orbiter(3,:), '-m', 'linewidth',3,'HandleVisibility','off')
plot3(xIJK,yIJK,zIJK,'-b', 'linewidth', 2)
xlabel('I [Km]')
ylabel('J [Km]')
zlabel('K [Km]')
grid
hold on
end 